<template>
	<view class="content">
		<view class="top">
			<u-search shape="square" :show-action="false" placeholder="请输入公证员姓名" @focus="toChange"></u-search>
		</view>
		<view class="bottom">
			<scroll-view scroll-y="true" class="scroll-view" @scrolltolower="toPage">
				<view class="list-scroll-view">
					<view class="list" v-for="(item, index) in list" :key="index" @tap="toView(item)">
						<view class="list_1">
							<view class="left">
								<image class="image" :src="item.logo&&item.logo.length>0?item.logo[0].url:''">
								</image>
							</view>
							<view class="right">
								<view class="name textOver">{{item.zw||'暂无'}}: {{item.name||'暂无'}}</view>
								<view class="other">
									<text>专业: {{item.speciality||"暂无"}}</text>
								</view>
							</view>
						</view>
					</view>
					<view class="is_bottom" v-if="is_bottom">
						<text>{{config.bottom_title||'没有更多了！'}}</text>
					</view>
				</view>
			</scroll-view>
		</view>
	</view>
</template>

<script setup lang="ts">
	import { getCurrentInstance, ref } from 'vue';
	//该依赖已内置不需要单独安装
	import { onShow, onPullDownRefresh } from "@dcloudio/uni-app";
	// 请求接口
	const $api = getCurrentInstance()?.appContext.config.globalProperties.$api;
	// 搜索
	const searchName = ref('');
	// 基本信息
	const config = ref({ logo: [] });
	// 列表
	const list = ref([]);
	const total = ref(0);
	const skip = ref(0);
	const limit = ref(6);
	const page = ref(0);
	// 数据是否触底
	const is_bottom = ref(false);
	const scrollTop = ref(0);
	onShow(async () => {
		await searchConfig();
		await clearPage();
		await search();
	})
	onPullDownRefresh(async () => {
		await clearPage();
		await search();
		uni.stopPullDownRefresh();
	})
	// config信息
	const searchConfig = async () => {
		config.value = uni.getStorageSync('config');
	};
	// 查询
	const search = async () => {
		const info = {
			skip: skip.value,
			limit: limit.value,
			is_use: '0'
		}
		if (searchName.value) info.name = searchName.value
		const res = await $api('personnel', 'GET', info);
		if (res.errcode === 0) {
			list.value = list.value.concat(res.data)
			total.value = res.total
		} else {
			uni.showToast({
				title: res.errmsg || '',
				icon: 'error',
			});
		}
	};
	// 搜索
	const toChange = async (e) => {
		if (e) searchName.value = e
		else searchName.value = ''
		await clearPage();
		await search();
	};
	// 查看详情
	const toView = (item) => {
		uni.navigateTo({
			url: `/pagesHome/personnel/detail?id=${item.id || item._id}`
		})
	};
	// 分页
	const toPage = () => {
		if (total.value > list.value.length) {
			uni.showLoading({
				title: '加载中',
				mask: true
			})
			page.value = page.value + 1;
			skip.value = page.value * limit.value;
			search();
			uni.hideLoading();
		} else is_bottom.value = true
	};
	// 清空列表
	const clearPage = () => {
		list.value = []
		skip.value = 0
		limit.value = 6
		page.value = 0
	};
</script>
<style lang="scss" scoped>
	.content {
		display: flex;
		flex-direction: column;
		width: 100vw;
		height: 100vh;

		.top {
			margin: 2vw;
		}

		.bottom {
			position: relative;
			flex-grow: 1;
			background-color: var(--f1Color);

			.list {
				width: 46vw;
				margin: 2vw 0 0 0;
				border-radius: 5px;
				border: 1px solid var(--f5Color);
				background-color: var(--mainColor);

				.list_1 {
					.left {
						.image {
							width: 100%;
							height: 125px;
							border-radius: 5px 5px 0 0;
						}
					}

					.right {
						display: flex;
						flex-direction: column;
						justify-content: space-between;
						padding: 2vw;

						.name {
							margin: 2vw 0;
							font-size: var(--font16Size);
						}

						.other {
							font-size: var(--font14Size);
							color: var(--f85Color);
						}
					}
				}
			}
		}
	}

	.scroll-view {
		position: absolute;
		top: 0;
		left: 0;
		right: 0;
		bottom: 0;

		.list-scroll-view {
			display: flex;
			justify-content: space-between;
			flex-wrap: wrap;
			padding: 0 2vw;
		}
	}

	.is_bottom {
		width: 100%;
		text-align: center;

		text {
			padding: 2vw 0;
			display: inline-block;
			color: var(--f85Color);
			font-size: var(--font12Size);
		}
	}
</style>